----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 23.05.2022 12:32:36
-- Design Name: 
-- Module Name: pulse_gen - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pulse_gen is
	port(
	    clk         : in std_logic;
		pulse_in 	: in std_logic;
		pulse_out	: out std_logic
	);
end pulse_gen;

architecture Behavioral of pulse_gen is

signal q1,q2 : std_logic;

begin

pulse_gen_p: process (clk)
begin

  if rising_edge(clk) then
    q1 <= pulse_in;
    q2 <= q1;
  end if;

end process;

pulse_out <= q1 and (not q2);

end Behavioral;
